#
# chains.py
#
"""
Methods to find various kinds of WAS transport chains.
Useful if you have to secure any service integration buses.
"""

import AdminConfig

#findChains
#  Gets a list of all known transport chains in a cell and cull that chain
#  to find chains that have configuration IDs that interest us
#Parameters:
#  cullString - look for chains that have this string
#               as part of their configuration IDs
#  return value - a list of interesting chains
def findChains( cullString ):
  """Gets a list of all known transport chains in a cell and cull that chain to find chains that have configuration IDs that interest us\nParameters:\n  cullString - look for chains that have this string as part of their configuration IDs\n  return value - a list of interesting chains"""
  array = []
  interestingChains = []
  #find all the chains in the cell
  raw = AdminConfig.list( 'Chain' )
  if len(raw) > ArbitraryMinimumStringLength:
    array = raw.splitlines()
  else:
    print "We did not seem to get any Chains"
    print " - - >" + raw + "< - -"
    return
  for c in array:
    if c.find( cullString ) > -1:
      interestingChains.append(c)
  return interestingChains


#findMesssagingChains
#  Gets all the messaging chains we can find and prints them
def findMessagingChains():
  """Gets all the messaging chains we can find and prints them"""
  stuff = findChains( "BasicMessag" )
  print "\n            Insecure Chains"
  for s in stuff:
    if AdminConfig.showAttribute( s, 'enable' ) == 'true':
      print s
  stuff = findChains( "DCS(" )
  for s in stuff:
    if AdminConfig.showAttribute( s, 'enable' ) == 'true':
      print s
  stuff = findChains( "SecureMessag" )
  print "\n            Secure Chains"
  for s in stuff:
    if AdminConfig.showAttribute( s, 'enable' ) == 'true':
      print s
  stuff = findChains( "DCS-Secure" )
  for s in stuff:
    if AdminConfig.showAttribute( s, 'enable' ) == 'true':
      print s
  return



# main method starts here
"""Various methods that play with TransportChains"""
ArbitraryMinimumStringLength = 5
if __name__ == "main":
  print "Running standalone . . ."
else:
  print  __name__ , "module is loaded"

