#convertJACL.py
#
#Routines that convert things from JACL format to Python format

"Utility methods that convert JACL things into Python things"

#list()
#convert a JACL list into a Jython list
#parameters:
#    jaclList - a String that represents a JACL list
#returns:
#    a Python List
def list( jaclList ):
  "list()\nconvert a JACL list into a Jython list\nparameters:\n    jaclList - a String that represents a JACL list\nreturns:\n    a Python List\n"
  result = []
  # remove outter square brackets
  x = jaclList.replace( '[',' ')
  x = x.replace( ']',' ')
  x = x.strip()
  
  # use a comma to separate items on the list
  x = x.replace(   ') ' ,  '),'   )
  for t in x.split( ',' ):
    result.append(t)
  
  return result

def dumpPropertySet( setName, jaclList ):
  """Find a property and change its value\nparameters:\n   setName - String - the name of the propertySet\n   jaclList - very long String - the complete value returned by AdminConfig.showAttribute() nested inside AdminConfig.show()"""
  delimeter = '`'
  # remove distractions
  jaclList = jaclList.replace( '[' + setName + ' [', '' )
  jaclList = jaclList.replace( ']]', '' )
  #create a reliable delimiter
  jaclList = jaclList.replace( ') ', ')' + delimeter )
  listOfProperties = jaclList.split( delimeter )
  print "There are",len(listOfProperties), "properties\n"
  for p in listOfProperties:
    print AdminConfig.showAttribute( p, 'name' ) \
          + "    " + AdminConfig.showAttribute( p, 'type' ) \
          + "    " + AdminConfig.showAttribute( p, 'value' )
    print AdminConfig.showAttribute( p, 'description' ) + '\n'


def changePropertySet( setName, jaclList, propertyName, propertyValue ):
  """Find a property and change its value\nparameters:\n   setName - String - the name of the propertySet\n   jaclList - very long String - the complete value returned by AdminConfig.showAttribute() nested inside AdminConfig.show()\n   propertyName - String - the name of the property we wish to change\n   propertyValue - String - the new value.  '[]' means empty value\nYou may NOT change the name of a property\nYou must call AdminConfig.save() to make changes permanent"""
  delimeter = '`'
  # remove distractions
  jaclList = jaclList.replace( '[' + setName + ' [', '' )
  jaclList = jaclList.replace( ']]', '' )
  #create a reliable delimiter
  jaclList = jaclList.replace( ') ', ')' + delimeter )
  listOfProperties = jaclList.split( delimeter )
  for p in listOfProperties:
    if AdminConfig.showAttribute( p, 'name' ) == propertyName:
      if propertyValue == "[]":
        AdminConfig.modify( p, [[ 'value', [] ]] )
      else:
        AdminConfig.modify( p, [[ 'value', propertyValue ]] )
      print AdminConfig.queryChanges()
      break





#displayListItems()
#Displays each item in a List.  Each item is indented slightly
#parameters:
#    theList - a Python list
def displayListItems( theList ):
  for x in theList:
    print "   ",x



# main method starts here
if __name__ == "main":
  print "Running standalone . . ."
else:
  print  __name__ , "module is loaded"
  #print __name__,"can see "
  #print dir()
